/* ### CHECK-ME-BEFORE-RELEASE ### */
/*
 * Title:   win32time.c
 * Created: Spring 2000
 * Authors: Markus Noga, Tim Weyrich
 *     $Id: win32time.c,v 1.6 2003/11/19 10:37:31 weyrich Exp $
 *
 * Copyright (c) 2000--2003
 * Gilbert Baumann <unk6@stud.uni-karlsruhe.de>
 * Markus Noga <markus@noga.de>
 * Tim Weyrich <weyrich@inf.ethz.ch>
 *
 * This file is part of the Pointshop3D system.
 * See http: *www.pointshop3d.com/ for more information.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 * 
 * Contact info@pointshop3d.com if any conditions of this
 * licensing are not clear to you.
 *
 * ---------------------------------------------------------------
 *
 * $Log: win32time.c,v $
 * Revision 1.6  2003/11/19 10:37:31  weyrich
 * added Pointshop3D headers
 *
 *
 */

/*! \file   win32time.c
    \brief  Win32 time routines.
    \author Markus L. Noga, Tim Weyrich
*/

#include "win32windows.h"

#include "pitime.h"

#include <sys/timeb.h> /* for _ftime() */

//! Return system time in ms.
PI_API uint32 piSystemTime(void)
{
    return GetTickCount();
}

PI_API int gettimeofday (struct timeval * /*__restrict*/ __tv,
			 struct timezone *__tz)
{
  struct _timeb  tb;
  _ftime(&tb);
  __tv->tv_sec = tb.time;
  __tv->tv_usec = 1000 * tb.millitm;
  __tz->tz_minuteswest = tb.timezone;
  __tz->tz_dsttime = tb.dstflag;
  return 0;
}
