/* ### CHECK-ME-BEFORE-RELEASE ### */
/*
 * Title:   xtime.c
 * Created: Spring 2000
 * Authors: Markus Noga, Tim Weyrich
 *     $Id: xtime.c,v 1.2 2003/11/19 10:37:31 weyrich Exp $
 *
 * Copyright (c) 2000--2003
 * Gilbert Baumann <unk6@stud.uni-karlsruhe.de>
 * Markus Noga <markus@noga.de>
 * Tim Weyrich <weyrich@inf.ethz.ch>
 *
 * This file is part of the Pointshop3D system.
 * See http: *www.pointshop3d.com/ for more information.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 * Contact info@pointshop3d.com if any conditions of this
 * licensing are not clear to you.
 *
 * ---------------------------------------------------------------
 *
 * $Log: xtime.c,v $
 * Revision 1.2  2003/11/19 10:37:31  weyrich
 * added Pointshop3D headers
 *
 *
 */

/*! \file   xtime_c
    \brief  Unix/X11 time routines.
    \author Markus L. Noga, Tim Weyrich
*/

#define TAKE_USER_TIME  0

#if TAKE_USER_TIME
#  include <time.h>
#else
#  include <sys/time.h>
#endif

#include <pitime.h>

/*! Return system time in ms.*/
PI_API uint32 piSystemTime(void) {
#if TAKE_USER_TIME
  clock_t  clk = clock ( );
  return clk * 1000 / CLOCKS_PER_SEC;
#else
  struct timeval  tv;
  gettimeofday (&tv, NULL);
  return tv.tv_sec * 1000 + tv.tv_usec / 1000;
#endif
}
